<?php 
/*
*Template Name: Bolg 2Col
*/
?>
<?php get_header(); ?>
		<!-- page-banner-section 
			================================================== -->
		<section class="page-banner-section">
			<div class="container">
				<div class="row">
					<div class="col-md-6">
						<h2><?php single_post_title(); ?></h2>
					</div>
					<div class="col-md-6">
						<?php housebuild_breadcrumb(); ?>
					</div>
				</div>
			</div>
		</section>
		<!-- End page-banner section -->

		<!-- blog section 
			================================================== -->
		<section class="news-section col2">
			<div class="container">
				<div class="news-box iso-call">
					<?php 
						if(is_front_page()) {
							$paged = (get_query_var('page')) ? get_query_var('page') : 1;
						} else {
							$paged = (get_query_var('paged')) ? get_query_var('paged') : 1;
						}
						$args = array(
							'post_type' => 'post',
							'posts_per_page' =>6,
							'paged' => $paged,
						);
						$query = new WP_Query($args);
					?>
					 <?php 
					if($query->have_posts()) :
									while($query->have_posts()) : $query->the_post(); 
					?>
					
					<div class="news-post">
						<?php 
							if(has_post_thumbnail()){
							$img = housebuild_thumbnail_url('');
							$img_url = bfi_thumb($img, array('width'=>400, 'height'=> 300));
						?>
						<img src="<?php echo esc_attr($img_url); ?>" alt="<?php the_title(); ?>">
						<?php } ?>
						<h2><a href="<?php the_permalink(); ?>"><?php the_title(); ?></a></h2>
						<span><?php the_time('d F Y');?></span>
						<p><?php echo housebuild_excerpt($limit = 20);?></p>
						<a href="<?php the_permalink(); ?>"><?php _e('Continue Reading','housebuild'); ?>...</a>
					</div>
					<?php endwhile; ?>
					<?php else: ?>
					<div class="not-found">
							<h1><?php _e('Nothing Found Here!','oliver'); ?></h1>
							<h3><?php _e('Search with other string:', 'oliver') ?></h3>
							<div class="search-form">
									<?php get_search_form(); ?>
							</div>
					</div>
					<?php endif; ?>
					
				</div>
				<?php housebuild_pagination($prev = 'Prev', $next = 'Next', $pages=$query->max_num_pages); ?>
					
			</div>
		</section>
		<!-- End blog section -->
<?php get_footer(); ?>